/*------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        31.12.2007
 Description:    Analogeingnge Abfragen
 
 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/
#include "analog.h"
#include "lcd.h"
#include "roomcontrol.h"

#if USE_ADC
volatile unsigned char channel = 0;

//------------------------------------------------------------------------------
//
/*void ADC_Init(void)
{ 
	//Externe Referenzspannung verwenden (bei Tempsensor TC1047 1V an AREF einstellen)
	ADMUX |= ~((1<<REFS0) | (1<<REFS1));
	//ADC einschalten, Teilungsfaktor 128
	ADCSRA=(1<<ADEN)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);
}*/

//------------------------------------------------------------------------------
//
void ADCRead(void)
{
    double Ergebnis;
	for(channel = 0; channel < 2; channel++)
	{
		//ADC einschalten
		ADCSRA = (1<<ADEN) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);
		Ergebnis = 0;
		/*var_array[channel++] = ADC;
		var_array[channel-1] = (var_array[channel-1]-511)/10;
		if (channel > 0) channel = 0;
		ADMUX = ~(1<<REFS0) + channel;*/
		
		//--Messung--//
		//PortA messen
		ADMUX = channel;
		// Den ADC initialisieren und einen sog. Dummyreadout machen.
		// Es wird empfohlen das erste ausgelesene Signal nicht auszuwerten.
		ADCSRA |= (1<<ADSC);
		while(ADCSRA & (1<<ADSC)){}
		
		//Eigentliche Messung
		//3 Messungen starten und Durchschnitt berechnen
		for(int i = 0; i < 3; i++)
		{
			//Messwert erfassen
			ADCSRA |= (1<<ADSC);
			//Auf Ergebnis warten
			while(ADCSRA & (1<<ADSC));
			Ergebnis += ADC;
		}
		
		//ADC abschalten
		ADCSRA = 0;
		
		//Durchschnitt berechnen
		Ergebnis /= 3;
		
		//Temperatur berechnen
		//C = (Ergebnis-Offset)/Schritt pro Grad
		//Bei TC 1047 und 1V Uref:
		//Offset --> 511
		//Schritt pro Grad --> 10
		Ergebnis = (Ergebnis - OFFSET) / STEP_PER_DEGREE;
		//Ergebnis in var_array fr Website speichern
		var_array[channel] = (int)Ergebnis;
	}
	
	//Tempausgabe auf LCD
	#if USE_SER_LCD
		lcd_print(1,0,"Fen. %i, Tuer %i", var_array[0], var_array[1]);
	#endif //USE_SER_LCD
}

#endif //USE_ADC


