/*----------------------------------------------------------------------------
 Copyright:      Simon Jansen  mailto: simon.jansen1@googlemail.com
 Author:         Simon Jansen
 Remarks:        
 known Problems: none
 Version:        19.03.2008
 Description:    Raumsteuerung
----------------------------------------------------------------------------*/

#include "roomcontrol.h"

int DesiredTemperature = 30;
unsigned int HeatingMode = 0;
unsigned short ManualControl = 0;


void TemperatureControl (void)
{	
	var_array[2] = DesiredTemperature;
	if(ManualControl == 0)
	{
		if(var_array[0] <= DesiredTemperature - 2)
		{
			//Wenn "Soll"-Temperatur um mehr als 2 Grad unterschritten, volle Heizleistung
			HeatingMode = 1;
		}
		else if(var_array[0] <= DesiredTemperature - 1)
		{
			//Wenn "Soll"-Temperatur um mehr als 1 Grad unterschritten, halbe Heizleistung
			//HeatingMode = 2;
			HeatingMode = 2;
		}
		else
		{	
			//Wenn "Soll"-Temperatur erreicht, Heizungen aus
			HeatingMode = 0;
		}
	}
}


void WindowControl (void)
{
	//Analog aus
	ANALOG_OFF;
	
	if((REED_CONTACT_PORT & (1<<Window1)) && (REED_CONTACT_PORT & (1<<Window2)) && (REED_CONTACT_PORT & (1<<Window3)))
	{
		//Wenn alle Fenster offen, Heizung aus
		HeatingMode = 0;
	}
	
	else if((((REED_CONTACT_PORT & (1<<Window1)) && (REED_CONTACT_PORT & (1<<Window2))) ||
	((REED_CONTACT_PORT & (1<<Window2)) && (REED_CONTACT_PORT & (1<<Window3))) ||
	((REED_CONTACT_PORT & (1<<Window1)) && (REED_CONTACT_PORT & (1<<Window3)))) && 
	HeatingMode != 0)
	{
		//Wenn zwei Fenster offen (1 und 2, 2 und 3, 1 und 3) Heizung aus
		HeatingMode = 0;
	}
	
	else if(((REED_CONTACT_PORT & (1<<Window1)) || (REED_CONTACT_PORT & (1<<Window2)) || (REED_CONTACT_PORT & (1<<Window3))) && HeatingMode != 0)
	{
		//Wenn ein Fenster auf (1, 2, 3) Heizung aus
		HeatingMode = 0;
	}
	
	//Wenn Fenster zu, Heizungen temperaturabhngig (TemperatureControl) betreiben
	
	//Analog ein
	ANALOG_ON;
}

void HeatingControl (void)
{
	//HeatingMode in var_array fr Darstellung auf Webpage
	var_array[3] = HeatingMode;
	//HeatingMode 2 wird in timer.c abgearbeitet (Zeile 84)
	if(HeatingMode != 2)
	{
		switch(HeatingMode)
		{
			case 1:
				//Wenn HeatingMode auf 1 Heizung an 
				ELECTRONIC_SWITCH_PORT |= (1<<Heater1);
				break;
			case 0:
				//Wenn HeatingMode auf 0 Heizung aus
				ELECTRONIC_SWITCH_PORT &= ~(1<<Heater1);
				break;
		}
	}
	#if USE_SER_LCD
	lcd_print(0,0,"Heizung %i", HeatingMode);
	#endif //USE_SER_LCD
}
