/*----------------------------------------------------------------------------
 Copyright:      Simon Jansen  mailto: simon.jansen1@googlemail.com
 Author:         Simon Jansen
 Remarks:        
 known Problems: none
 Version:        19.03.2008
 Description:    Raumsteuerung
----------------------------------------------------------------------------*/

#include <avr/io.h>

#include "analog.h"
#include "lcd.h"

//--Ausgnge--//
//Port, an dem zu schaltende Gerte hngen
#define ELECTRONIC_SWITCH_PORT PORTD

//Lampen mit Nummer des Portausgangs
#define Light1 7
#define Light2 6
#define Light3 5
#define Light4 4

//Heizungsventil mit Nummer des Portausgangs
#define Heater1 3

//--Eingnge--//
//Port, an dem Reedkontakte hngen
#define REED_CONTACT_PORT PINA

//Reedkontakte mit Nummer des Ports
#define Window1 2
#define Window2 3
#define Window3 4

//Prototypes
void WindowControl(void);
void TemperatureControl(void);
void HeatingControl(void);

int DesiredTemperature;
unsigned int HeatingMode;
unsigned short ManualControl;
