/*----------------------------------------------------------------------------
 Copyright:      Simon Jansen  mailto: simon.jansen1@googlemail.com
 Author:         Simon Jansen
 Remarks:        
 known Problems: none
 Version:        19.03.2008
 Description:    Taster BCD Codierung
----------------------------------------------------------------------------*/

#include <avr/io.h>

#include "switch.h"

unsigned int Switch_Pressed(void)
{
	//Taster 8
	//PD5=L, PD6=L, PD7=L
	if(!(SWITCH_PORT & (1<<A0)) && (!(SWITCH_PORT & (1<<A1))) && (!(SWITCH_PORT & (1<<A2))))
	{
		PORTD ^= 0xF0;
		return 8;
	}
	
	//Taster 7
	//PD5=H, PD6=L, PD7=L
	if((SWITCH_PORT & (1<<A0)) && (!(SWITCH_PORT & (1<<A1))) && (!(SWITCH_PORT & (1<<A2))))
	{
		//PORTD |= 0x50;
		return 7;
	}
	
	//Taster 6
	//PD5=L, PD6=H, PD7=L
	if(!(SWITCH_PORT & (1<<A0)) && (SWITCH_PORT & (1<<A1)) && (!(SWITCH_PORT & (1<<A2))))
	{
		PORTD |= 0x00;
		return 6;
	}
	
	//Taster 5
	//PD5=H, PD6=H, PD7=L
	if((SWITCH_PORT & (1<<A0)) && (SWITCH_PORT & (1<<A1)) && (!(SWITCH_PORT & (1<<A2))))
	{
		return 5;
	}
	
	//Taster 1
	//PD5=L, PD6=L, PD7=H	
	if(!(SWITCH_PORT & (1<<A0)) && (!(SWITCH_PORT & (1<<A1))) && (SWITCH_PORT & (1<<A2)))
	{
		return 1;
	}
	
	//Taster 2
	//PD5=H, PD6=L, PD7=H	
	if((SWITCH_PORT & (1<<A0)) && (!(SWITCH_PORT & (1<<A1))) && (SWITCH_PORT & (1<<A2)))
	{
		return 2;
	}
	
	//Taster 3
	//PD5=L, PD6=H, PD7=H	
	if(!(SWITCH_PORT & (1<<A0)) && (SWITCH_PORT & (1<<A1)) && (SWITCH_PORT & (1<<A2)))
	{
		return 3;
	}
	
	//Taster 4
	//PD5=H, PD6=H, PD7=H	
	/*if((SWITCH_PORT & (1<<A0)) && (SWITCH_PORT & (1<<A1)) && (SWITCH_PORT & (1<<A2)))
	{
		return 4;
	}*/
	
	//Kein Taster
	else
	{
		return 0;
	}
}
